package PluS;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

public class ComponentBuilder {

		public Component createComponent(File f){
			Component comp = null;
		try {
			Document comDoc = (new SAXBuilder(true)).build(f);
			Element comDocRoot = comDoc.getRootElement();
			String pluginID = comDocRoot.getAttributeValue("ID");
			String library = comDocRoot.getChildText("library");
			
			Element pluginEl = comDocRoot.getChild("plugin");
			String hostID = pluginEl.getChildText("hostID");
			String extensionpointID = pluginEl.getChildText("extensionpointID");
			String pClass = pluginEl.getChildText("extension");
			
			List<String>extPoints;
			Element extEl = comDocRoot.getChild("extensionpoints");
			if(extEl!=null){
				extPoints = createExtensionPoints(comDocRoot.getChildren("extensionpoint"));
			}
			else extPoints = new ArrayList<String>();
			
			List<String> deps = new ArrayList<String>();
			Element depEl = comDocRoot.getChild("dependencies");
			if(depEl!=null){
				List dependencyEls = depEl.getChildren("dependency");
				for(Object obj:dependencyEls){
					if(obj instanceof Element){
						Element el = (Element) obj;
						deps.add(el.getText());
					}
				}
			}
			
			comp = new Component(pluginID, library, pClass, hostID, extensionpointID, extPoints, deps);
			
		} catch (JDOMException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return comp;
	}

		
		private List<String>createExtensionPoints(List extensionPoints){
			List<String> result = new ArrayList<String>();
			Iterator iter = extensionPoints.iterator();
			while(iter.hasNext()){
				Element extEl = (Element) iter.next();
				String extID = extEl.getChildText("extensionpoint");
				result.add(extID);
			}
			return result;
		}
}
